; XCOPY.ASM--
; Copyright (c) 2008 Hjort Nidudsson
;
; Change history:
; 12 Nov 2008	- Created

INCLUDE		clib.inc
INCLUDE		dos.inc
INCLUDE		arch.inc
INCLUDE		string.inc
INCLUDE		filter.inc
INCLUDE		progress.inc
INCLUDE		dzmain.inc

PPROC		xcopy_file	; int xcopy_file(const char *, wfblk *);
ARG		path:	DWORD,\
		wblk:	DWORD
		push	filter
		push	wblk
		call	filter_wblk
		or	ax,ax
		jz	SHORT @@toend
		mov	ax,ds
		push	ax
		push	OFFSET __srcfile; --> %path%\%name%
		push	path
		les	bx,wblk
		add	bx,wf_name
		push	es
		push	bx
		test	copy_flag,(_CPYOUTDZIP or _CPYOUTZIP)
		jnz	SHORT @@arch
		push	ax
		push	OFFSET __outfile; --> %outpath%\%name%
		push	ax
		push	OFFSET __outpath
		push	es
		push	bx
		call	strfcat
@@arch:		call	strfcat
		push	dx		; Init Progress
		push	ax
		push	dx
		push	OFFSET __outfile
		les	bx,wblk
		push	es:[bx.wf_sizeax]
		call	progress_set	; return 0 || ER_USERABORT
		or	ax,ax
		jnz	SHORT @@toend
		les	bx,wblk		; args: size, date, time, and attrib
		push	es:[bx.wf_sizeax]
		push	es:[bx.wf_datemodified]
		push	es:[bx.wf_timemodified]
		mov	ax,WORD PTR ES:[bx.wf_attrib]
		and	ax,_A_FATTRIB
		push	ax
IFDEF _DZIP_
		test	copy_flag,_CPYOUTDZIP
		jnz	SHORT @@dzip
ENDIF
		test	copy_flag,_CPYOUTZIP
		jnz	SHORT @@zip
		call	copyfile
@@toend:	ret
IFDEF _DZIP_
@@dzip:		call	dzipadd
		jmp	SHORT @@toend
ENDIF
@@zip:		call	wzipadd
		jmp	SHORT @@toend
PEND		xcopy_file

PPROC		cmcopyfile	; int cmcopyfile(FBLK *, int __virgin);
ARG		@@b:	DPTR,\
		@@virg:	WORD
		push	filter
		push	@@b
		call	filter_fblk
		or	ax,ax
		jnz	SHORT @@copy
		jmp	@@toend
@@copy:		mov	ax,DS
		push	ax
		push	OFFSET __srcfile
		push	ax
		push	OFFSET __srcpath
		mov	eax,@@b
		add	ax,fb_name
		push	eax
		call	strfcat
		xor	ax,ax
		cmp	ax,@@virg
		jne	SHORT @@progress
		test	copy_flag,(_CPYOUTDZIP or _CPYOUTZIP)
		jnz	SHORT @@progress
		mov	ax,DS
		push	ax
		push	OFFSET __outfile
		push	ax
		push	OFFSET __outpath
		mov	eax,@@b
		add	ax,fb_name
		push	eax
		call	strfcat
@@progress:	push	DS
		push	OFFSET __srcfile
		push	DS
		push	OFFSET __outfile
		les	bx,@@b
		push	ES:[bx.fb_size]
		call	progress_set
		or	ax,ax
		jnz	SHORT @@toend
		les	bx,@@b
		test	ES:[bx.fb_flag],_A_ARCHIVE
		jnz	SHORT @@decomp
		push	ES:[bx.fb_size]
		push	ES:[bx.fb_date]
		push	ES:[bx.fb_time]
		push	ES:[bx.fb_flag]
IFDEF _DZIP_
		test	copy_flag,_CPYOUTDZIP
		jnz	SHORT @@dzip
ENDIF
		test	copy_flag,_CPYOUTZIP
		jnz	SHORT @@zip
		call	copyfile
@@toend:	ret
IFDEF _DZIP_
@@dzip:		call	dzipadd
		jmp	SHORT @@toend
ENDIF
@@zip:		call	wzipadd
		jmp	SHORT @@toend
@@decomp:       mov	bx,WORD PTR cpanel
		push	[bx.pn_wsub]
		push	@@b
		push	DS
		push	OFFSET __outpath
		call	wsdecomp
		jmp	SHORT @@toend
PEND		cmcopyfile

		END
